Open CASCADE Technology: Select3D_SensitiveWire Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Member Functions
Select3D_SensitiveWire Class Reference

A framework to define selection of a wire owner by an elastic wire band. More...

`#include <Select3D_SensitiveWire.hxx>`

Inheritance diagram for Select3D_SensitiveWire:
[legend]

## Public Member Functions
| Select3D_SensitiveWire (const Handle< SelectBasics_EntityOwner > &theOwnerId)
| Constructs a sensitive wire object defined by the owner theOwnerId. More...
void | Add (const Handle< Select3D_SensitiveEntity > &theSensitive)
| Adds the sensitive entity theSensitive to this framework. More...
virtual Standard_Integer | NbSubElements () Standard_OVERRIDE
| Returns the amount of sub-entities. More...
virtual Handle< Select3D_SensitiveEntity > | GetConnected () Standard_OVERRIDE
| Originally this method intended to return sensitive entity with new location aLocation, but currently sensitive entities do not hold a location, instead HasLocation() and Location() methods call corresponding entity owner's methods. Thus all entities returned by GetConnected() share the same location propagated from corresponding selectable object. You must redefine this function for any type of sensitive entity which can accept another connected sensitive entity.//can be connected to another sensitive entity. More...
const NCollection_Vector< Handle< Select3D_SensitiveEntity > > & | GetEdges ()
| returns the sensitive edges stored in this wire More...
void | Set (const Handle< SelectBasics_EntityOwner > &theOwnerId)
| Sets the owner for all entities in wire. More...
Handle_Select3D_SensitiveEntity | GetLastDetected () const
virtual Select3D_BndBox3d | BoundingBox () Standard_OVERRIDE
| Returns bounding box of the wire. If location transformation is set, it will be applied. More...
virtual gp_Pnt | CenterOfGeometry () const Standard_OVERRIDE
| Returns center of the wire. If location transformation is set, it will be applied. More...
virtual Standard_Integer | Size () const Standard_OVERRIDE
| Returns the length of vector of sensitive entities. More...
virtual Select3D_BndBox3d | Box (const Standard_Integer theIdx) const Standard_OVERRIDE
| Returns bounding box of sensitive entity with index theIdx. More...
virtual Standard_Real | Center (const Standard_Integer theIdx, const Standard_Integer theAxis) const Standard_OVERRIDE
| Returns geometry center of sensitive entity index theIdx in the vector along the given axis theAxis. More...
virtual void | Swap (const Standard_Integer theIdx1, const Standard_Integer theIdx2) Standard_OVERRIDE
| Swaps items with indexes theIdx1 and theIdx2 in the vector. More...
Public Member Functions inherited from Select3D_SensitiveSet
| Select3D_SensitiveSet (const Handle< SelectBasics_EntityOwner > &theOwnerId)
| Creates new empty sensitive set and its content. More...
| ~Select3D_SensitiveSet ()
virtual Standard_Boolean | Matches (SelectBasics_SelectingVolumeManager &theMgr, SelectBasics_PickResult &thePickResult) Standard_OVERRIDE
| Checks whether one or more entities of the set overlap current selecting volume. Implements the traverse of BVH tree built for the set. More...
void | BVH ()
| Builds BVH tree for sensitive set. Must be called manually to build BVH tree for any sensitive set in case if its content was initialized not in a constructor, but element by element. More...
void | MarkDirty ()
| Marks BVH tree of the set as outdated. It will be rebuild at the next call of BVH() More...
virtual void | Clear () Standard_OVERRIDE
| Destroys cross-reference to avoid memory leak. More...
Standard_Integer | GetLeafNodeSize () const
| Returns a number of nodes in 1 BVH leaf. More...
Public Member Functions inherited from Select3D_SensitiveEntity
virtual Standard_Boolean | HasInitLocation () const Standard_OVERRIDE
| Returns true if the shape corresponding to the entity has init location. More...
virtual gp_Trsf | InvInitLocation () const
| Returns inversed location transformation matrix if the shape corresponding to this entity has init location set. Otherwise, returns identity matrix. More...
Public Member Functions inherited from SelectBasics_SensitiveEntity
const Handle< SelectBasics_EntityOwner > & | OwnerId () const
| Returns pointer to owner of the entity. More...
void | SetSensitivityFactor (const Standard_Integer theSensFactor)
| Allows to manage the sensitivity of the entity. More...
Standard_Integer | SensitivityFactor () const
| allows a better sensitivity for a specific entity in selection algorithms useful for small sized entities. More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Protected Member Functions
virtual Standard_Boolean | overlapsElement (SelectBasics_SelectingVolumeManager &theMgr, Standard_Integer theElemIdx, Standard_Real &theMatchDepth) Standard_OVERRIDE
| Checks whether the entity with index theIdx overlaps the current selecting volume. More...
virtual Standard_Boolean | elementIsInside (SelectBasics_SelectingVolumeManager &theMgr, const Standard_Integer theElemIdx) Standard_OVERRIDE
| Checks whether the entity with index theIdx is inside the current selecting volume. More...
virtual Standard_Real | distanceToCOG (SelectBasics_SelectingVolumeManager &theMgr) Standard_OVERRIDE
| Calculates distance from the 3d projection of used-picked screen point to center of the geometry. More...
Protected Member Functions inherited from Select3D_SensitiveEntity
| Select3D_SensitiveEntity (const Handle< SelectBasics_EntityOwner > &theOwnerId)
Protected Member Functions inherited from SelectBasics_SensitiveEntity
| SelectBasics_SensitiveEntity (const Handle< SelectBasics_EntityOwner > &theOwnerId, const Standard_Integer theSensFactor=2)

## Additional Inherited Members
Protected Attributes inherited from Select3D_SensitiveSet
Standard_Integer | myDetectedIdx
| Index of detected primitive in BVH sorted primitive array, for debug purposes. More...
Protected Attributes inherited from SelectBasics_SensitiveEntity
Handle< SelectBasics_EntityOwner > | myOwnerId

## Detailed Description

A framework to define selection of a wire owner by an elastic wire band.

## Constructor & Destructor Documentation

Select3D_SensitiveWire::Select3D_SensitiveWire | ( | const Handle< SelectBasics_EntityOwner > & | theOwnerId | ) |

Constructs a sensitive wire object defined by the owner theOwnerId.

## Member Function Documentation

void Select3D_SensitiveWire::Add | ( | const Handle< Select3D_SensitiveEntity > & | theSensitive | ) |

Adds the sensitive entity theSensitive to this framework.

virtual Select3D_BndBox3d Select3D_SensitiveWire::BoundingBox | ( |  | ) |
| virtual

Returns bounding box of the wire. If location transformation is set, it will be applied.

Reimplemented from Select3D_SensitiveSet.

virtual Select3D_BndBox3d Select3D_SensitiveWire::Box | ( | const Standard_Integer | theIdx | ) | const
| virtual

Returns bounding box of sensitive entity with index theIdx.

Implements Select3D_SensitiveSet.

virtual Standard_Real Select3D_SensitiveWire::Center | ( | const Standard_Integer | theIdx,
|  | const Standard_Integer | theAxis
| ) |  | const
| virtual

Returns geometry center of sensitive entity index theIdx in the vector along the given axis theAxis.

Implements Select3D_SensitiveSet.

virtual gp_Pnt Select3D_SensitiveWire::CenterOfGeometry | ( |  | ) | const
| virtual

Returns center of the wire. If location transformation is set, it will be applied.

Reimplemented from Select3D_SensitiveSet.

virtual Standard_Real Select3D_SensitiveWire::distanceToCOG | ( | SelectBasics_SelectingVolumeManager & | theMgr | ) |
| protectedvirtual

Calculates distance from the 3d projection of used-picked screen point to center of the geometry.

Implements Select3D_SensitiveSet.

virtual Standard_Boolean Select3D_SensitiveWire::elementIsInside | ( | SelectBasics_SelectingVolumeManager & | theMgr,
|  | const Standard_Integer | theElemIdx
| ) |  |
| protectedvirtual

Checks whether the entity with index theIdx is inside the current selecting volume.

Implements Select3D_SensitiveSet.

virtual Handle< Select3D_SensitiveEntity > Select3D_SensitiveWire::GetConnected | ( |  | ) |
| virtual

Originally this method intended to return sensitive entity with new location aLocation, but currently sensitive entities do not hold a location, instead HasLocation() and Location() methods call corresponding entity owner's methods. Thus all entities returned by GetConnected() share the same location propagated from corresponding selectable object. You must redefine this function for any type of sensitive entity which can accept another connected sensitive entity.//can be connected to another sensitive entity.

Reimplemented from Select3D_SensitiveEntity.

const NCollection_Vector<Handle< Select3D_SensitiveEntity > >& Select3D_SensitiveWire::GetEdges | ( |  | ) |

returns the sensitive edges stored in this wire

Handle_Select3D_SensitiveEntity Select3D_SensitiveWire::GetLastDetected | ( |  | ) | const

virtual Standard_Integer Select3D_SensitiveWire::NbSubElements | ( |  | ) |
| virtual

Returns the amount of sub-entities.

Implements Select3D_SensitiveEntity.

virtual Standard_Boolean Select3D_SensitiveWire::overlapsElement | ( | SelectBasics_SelectingVolumeManager & | theMgr,
|  | Standard_Integer | theElemIdx,
|  | Standard_Real & | theMatchDepth
| ) |  |
| protectedvirtual

Checks whether the entity with index theIdx overlaps the current selecting volume.

Implements Select3D_SensitiveSet.

void Select3D_SensitiveWire::Set | ( | const Handle< SelectBasics_EntityOwner > & | theOwnerId | ) |
| virtual

Sets the owner for all entities in wire.

Reimplemented from SelectBasics_SensitiveEntity.

virtual Standard_Integer Select3D_SensitiveWire::Size | ( |  | ) | const
| virtual

Returns the length of vector of sensitive entities.

Implements Select3D_SensitiveSet.

virtual void Select3D_SensitiveWire::Swap | ( | const Standard_Integer | theIdx1,
|  | const Standard_Integer | theIdx2
| ) |  |
| virtual

Swaps items with indexes theIdx1 and theIdx2 in the vector.

Implements Select3D_SensitiveSet.

The documentation for this class was generated from the following file:

- Select3D_SensitiveWire.hxx